# Detect the distribution in use
%global __despace head -n 1 | tr -d '[:space:]' | sed -e 's/[(].*[)]//g'
%global __lower4 cut -c 1-4 | tr '[:upper:]' '[:lower:]'
%global __distfile %([ -f /etc/SuSE-release ] && echo /etc/SuSE-release || echo /etc/redhat-release)
%global __distinit %(sed -e 's/ release .*//' -e 's/\\([A-Za-z]\\)[^ ]*/\\1/g' %{__distfile} | %{__despace} | %{__lower4})
%global __distvers %(sed -e 's/.* release \\([^. ]*\\).*/\\1/' %{__distfile} | %{__despace})
# Identify Alma, CentOS, CentOS Stream and Rocky Linux as rhel
%if "%{__distinit}" == "a" || "%{__distinit}" == "c" || "%{__distinit}" == "cl" || "%{__distinit}" == "cs" || "%{__distinit}" == "rl"
%global __distinit rhel
%endif
# Dist tag for Fedora is still "fc"
%if "%{__distinit}" == "f"
%global __distinit fc
%endif

Name:		perl-Specio
Version:	0.50
Release:	1.%{__distinit}%{__distvers}
Summary:	Type constraints and coercions for Perl
# lib/Specio/PartialDump.pm:	GPL-1.0-or-later OR Artistic-1.0-Perl
#				<https://github.com/houseabsolute/Specio/issues/17>
# Other files:			Artistic-2.0
License:	Artistic-2.0 AND (GPL-1.0-or-later OR Artistic-1.0-Perl)
URL:		https://metacpan.org/release/Specio
Source0:	https://cpan.metacpan.org/modules/by-module/Test/Specio-%{version}.tar.gz
BuildArch:	noarch
# Module Build
BuildRequires:	coreutils
BuildRequires:	make
BuildRequires:	perl-generators
BuildRequires:	perl-interpreter
BuildRequires:	perl(ExtUtils::MakeMaker) >= 6.76
# Module Runtime
BuildRequires:	perl(Carp)
BuildRequires:	perl(Clone)
BuildRequires:	perl(Devel::StackTrace)
BuildRequires:	perl(Eval::Closure)
BuildRequires:	perl(Exporter)
BuildRequires:	perl(IO::File)
BuildRequires:	perl(List::Util) >= 1.33
BuildRequires:	perl(Module::Runtime)
BuildRequires:	perl(MRO::Compat)
BuildRequires:	perl(overload)
BuildRequires:	perl(parent)
BuildRequires:	perl(re)
BuildRequires:	perl(Ref::Util) >= 0.112
BuildRequires:	perl(Role::Tiny) >= 1.003003
BuildRequires:	perl(Role::Tiny::With)
BuildRequires:	perl(Scalar::Util)
BuildRequires:	perl(strict)
BuildRequires:	perl(Sub::Quote)
BuildRequires:	perl(Sub::Util) >= 1.40
BuildRequires:	perl(Test::Fatal)
BuildRequires:	perl(Test::More) >= 0.96
BuildRequires:	perl(Try::Tiny)
BuildRequires:	perl(version) >= 0.83
BuildRequires:	perl(warnings)
BuildRequires:	perl(XString)
# Test Suite
BuildRequires:	perl(File::Spec)
BuildRequires:	perl(FindBin)
BuildRequires:	perl(lib)
BuildRequires:	perl(open)
BuildRequires:	perl(Test::Needs)
BuildRequires:	perl(utf8)
# Optional Tests (note: Moose/Mouse use DateTime and hence Specio in their test suites)
BuildRequires:	perl(CPAN::Meta) >= 2.120900
BuildRequires:	perl(CPAN::Meta::Prereqs)
%if 0%{!?perl_bootstrap:1}
BuildRequires:	perl(Moo)
BuildRequires:	perl(Moose) >= 2.1207
BuildRequires:	perl(Mouse)
%endif
BuildRequires:	perl(namespace::autoclean)
# Dependencies
%if 0%{?fedora} < 38 && 0%{?rhel} < 10
Requires:	perl(:MODULE_COMPAT_%(eval "`perl -V:version`"; echo $version))
%endif
Requires:	perl(Ref::Util) >= 0.112
Requires:	perl(Sub::Util) >= 1.40
Requires:	perl(XString)

# Avoid provides for private packages
%global __provides_exclude ^perl\\(_T::.*\\)

%description
The Specio distribution provides classes for representing type constraints
and coercion, along with syntax sugar for declaring them.

Note that this is not a proper type system for Perl. Nothing in this
distribution will magically make the Perl interpreter start checking a value's
type on assignment to a variable. In fact, there's no built-in way to apply a
type to a variable at all.

Instead, you can explicitly check a value against a type, and optionally coerce
values to that type.

%package -n perl-Test-Specio
Summary:	Test helpers for Specio
License:	Artistic-2.0
Requires:	%{name} = %{version}-%{release}

%description -n perl-Test-Specio
This package provides some helper functions and variables for testing Specio
types.

%prep
%setup -q -n Specio-%{version}

%build
perl Makefile.PL INSTALLDIRS=vendor NO_PACKLIST=1 NO_PERLLOCAL=1
%{make_build}

%install
%{make_install}
%{_fixperms} -c %{buildroot}

%check
make test

%files
%license LICENSE
%doc Changes CODE_OF_CONDUCT.md CONTRIBUTING.md README.md TODO.md
%{perl_vendorlib}/Specio.pm
%{perl_vendorlib}/Specio/
%{_mandir}/man3/Specio.3*
%{_mandir}/man3/Specio::Coercion.3*
%{_mandir}/man3/Specio::Constraint::AnyCan.3*
%{_mandir}/man3/Specio::Constraint::AnyDoes.3*
%{_mandir}/man3/Specio::Constraint::AnyIsa.3*
%{_mandir}/man3/Specio::Constraint::Enum.3*
%{_mandir}/man3/Specio::Constraint::Intersection.3*
%{_mandir}/man3/Specio::Constraint::ObjectCan.3*
%{_mandir}/man3/Specio::Constraint::ObjectDoes.3*
%{_mandir}/man3/Specio::Constraint::ObjectIsa.3*
%{_mandir}/man3/Specio::Constraint::Parameterizable.3*
%{_mandir}/man3/Specio::Constraint::Parameterized.3*
%{_mandir}/man3/Specio::Constraint::Role::CanType.3*
%{_mandir}/man3/Specio::Constraint::Role::DoesType.3*
%{_mandir}/man3/Specio::Constraint::Role::Interface.3*
%{_mandir}/man3/Specio::Constraint::Role::IsaType.3*
%{_mandir}/man3/Specio::Constraint::Simple.3*
%{_mandir}/man3/Specio::Constraint::Structurable.3*
%{_mandir}/man3/Specio::Constraint::Structured.3*
%{_mandir}/man3/Specio::Constraint::Union.3*
%{_mandir}/man3/Specio::Declare.3*
%{_mandir}/man3/Specio::DeclaredAt.3*
%{_mandir}/man3/Specio::Exception.3*
%{_mandir}/man3/Specio::Exporter.3*
%{_mandir}/man3/Specio::Helpers.3*
%{_mandir}/man3/Specio::Library::Builtins.3*
%{_mandir}/man3/Specio::Library::Numeric.3*
%{_mandir}/man3/Specio::Library::Perl.3*
%{_mandir}/man3/Specio::Library::String.3*
%{_mandir}/man3/Specio::Library::Structured.3*
%{_mandir}/man3/Specio::Library::Structured::Dict.3*
%{_mandir}/man3/Specio::Library::Structured::Map.3*
%{_mandir}/man3/Specio::Library::Structured::Tuple.3*
%{_mandir}/man3/Specio::OO.3*
%{_mandir}/man3/Specio::PartialDump.3*
%{_mandir}/man3/Specio::Registry.3*
%{_mandir}/man3/Specio::Role::Inlinable.3*
%{_mandir}/man3/Specio::Subs.3*
%{_mandir}/man3/Specio::TypeChecks.3*

%files -n perl-Test-Specio
%{perl_vendorlib}/Test/
%{_mandir}/man3/Test::Specio.3*

%changelog
* Wed Feb 19 2025 Paul Howarth <paul@city-fan.org> - 0.50-1
- Update to 0.50
  - Fixed a bug in the Int type that caused it to accept numbers like
    124512.000000000123, which when stringified, are stringified as integers
- Drop EL-7 support
  - Always have List::Util ≥ 1.33
  - Always have Sub::Util
  - Use %%{make_build} and %%{make_install}

* Sun Jan 19 2025 Paul Howarth <paul@city-fan.org> - 0.49-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_42_Mass_Rebuild

* Tue Dec 24 2024 Paul Howarth <paul@city-fan.org> - 0.49-1
- Update to 0.49
  - Attempting to import any structured type caused a confusing
    "Can't store CODE items" error
  - Removed the "this is alpha" warning from Specio::Library::Structured; it's
    as production-ready as it's going to get

* Mon Jul 22 2024 Paul Howarth <paul@city-fan.org> - 0.48-7
- Rebuilt for https://fedoraproject.org/wiki/Fedora_41_Mass_Rebuild

* Fri Jan 26 2024 Paul Howarth <paul@city-fan.org> - 0.48-6
- Re-rebuilt for https://fedoraproject.org/wiki/Fedora_40_Mass_Rebuild
  (see https://pagure.io/releng/issue/11888)

* Mon Jan 22 2024 Paul Howarth <paul@city-fan.org> - 0.48-5
- Rebuilt for https://fedoraproject.org/wiki/Fedora_40_Mass_Rebuild

* Fri Jul 21 2023 Paul Howarth <paul@city-fan.org> - 0.48-4
- Rebuilt for https://fedoraproject.org/wiki/Fedora_39_Mass_Rebuild

* Tue Jan 24 2023 Paul Howarth <paul@city-fan.org> - 0.48-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_38_Mass_Rebuild

* Sat Jul 23 2022 Paul Howarth <paul@city-fan.org> - 0.48-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_37_Mass_Rebuild

* Sun Jun 12 2022 Paul Howarth <paul@city-fan.org> - 0.48-1
- Update to 0.48
  - Importing types into a class that inherited from another class that had
    imported types wouldn't work, leaving the child class with no 't()' sub

* Tue Jun  7 2022 Paul Howarth <paul@city-fan.org> - 0.47-7
- Perl 5.36 rebuild

* Mon Jan 24 2022 Paul Howarth <paul@city-fan.org> - 0.47-5
- Rebuilt for https://fedoraproject.org/wiki/Fedora_36_Mass_Rebuild

* Tue Jul 27 2021 Paul Howarth <paul@city-fan.org> - 0.47-4
- Rebuilt for https://fedoraproject.org/wiki/Fedora_35_Mass_Rebuild
- Fix dist tags for Alma and Rocky Linux

* Tue May 25 2021 Paul Howarth <paul@city-fan.org> - 0.47-3
- Perl 5.34 rebuild

* Sun Jan 31 2021 Paul Howarth <paul@city-fan.org> - 0.47-1
- Update to 0.47
  - Change Specio constraint object's stringification overloading to return the
    type name rather than the default Perl object stringification, which gives
    you something like
    "Specio::Constraint::Parameterized=HASH(0x564d258efb48)"; anonymous types
    are special cased to return something you can print
  - All types now overload the 'eq' comparison operator: Moose expects types to
    be comparable in this manner when doing role summation (GH#18)
- Drop support for EOL distributions prior to F-19
  - Assume we have rpm ≥ 4.9
  - Use %%license unconditionally

* Thu Jul 30 2020 Paul Howarth <paul@city-fan.org> - 0.46-4
- Rebuilt for https://fedoraproject.org/wiki/Fedora_33_Mass_Rebuild

* Mon Jun 29 2020 Paul Howarth <paul@city-fan.org> - 0.46-3
- Perl 5.32 rebuild

* Sat Mar 14 2020 Paul Howarth <paul@city-fan.org> - 0.46-1
- Update to 0.46
  - Correct license of Specio::PartialDump (GH#17)

* Tue Feb 18 2020 Paul Howarth <paul@city-fan.org> - 0.45-3
- Correct the perl-Specio license to "Artistic 2.0 and (GPL+ or Artistic)"

* Thu Feb  6 2020 Paul Howarth <paul@city-fan.org> - 0.45-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_32_Mass_Rebuild

* Mon Nov 25 2019 Paul Howarth <paul@city-fan.org> - 0.45-1
- Update to 0.45
  - Made XString a prereq if installing with Perl 5.10+

* Thu Aug 15 2019 Paul Howarth <paul@city-fan.org> - 0.44-1
- Update to 0.44
  - Replaced the use of B with XString if it is installed; the latter is much
    smaller and provides the one subroutine from B we cared about (based on
    GH#15)

* Fri Jul 26 2019 Paul Howarth <paul@city-fan.org> - 0.43-5
- Rebuilt for https://fedoraproject.org/wiki/Fedora_31_Mass_Rebuild

* Sat Jun  8 2019 Paul Howarth <paul@city-fan.org> - 0.43-4
- Perl 5.30 rebuild

* Wed Feb  6 2019 Paul Howarth <paul@city-fan.org> - 0.43-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_30_Mass_Rebuild

* Sun Oct 28 2018 Paul Howarth <paul@city-fan.org> - 0.43-1
- Update to 0.43
  - Optimized compile-time operations to make Specio itself quicker to load;
    Specio's load time is a non-trivial part of the load time of DateTime (and
    presumably other things that use it)
  - Based on https://github.com/houseabsolute/DateTime.pm/issues/85
- Package new CODE_OF_CONDUCT.md file

* Sat Jul 21 2018 Paul Howarth <paul@city-fan.org> - 0.42-5
- Rebuilt for https://fedoraproject.org/wiki/Fedora_29_Mass_Rebuild

* Tue Jul 10 2018 Paul Howarth <paul@city-fan.org> - 0.42-4
- Switch upstream from search.cpan.org to metacpan.org

* Mon Feb 19 2018 Paul Howarth <paul@city-fan.org> - 0.42-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_28_Mass_Rebuild

* Mon Nov  6 2017 Paul Howarth <paul@city-fan.org> - 0.42-1
- Update to 0.42
  - Fixed checks for whether a class is loaded in light of upcoming
    optimization in Perl 5.28 (GH#12)
  - The Perl library claimed it provided types named LaxVersionStr and
    StrictVersionStr but they were really named LaxVersion and StrictVersion;
    the names have now been fixed to match the documentation, so they are
    LaxVersionStr and StrictVersionStr

* Fri Aug  4 2017 Paul Howarth <paul@city-fan.org> - 0.40-1
- Update to 0.40
  - Fixed more bugs with {any,object}_{can,does,isa}_type
    - When passed a glob (not a globref) they would die in their type check
    - On Perl 5.16 or earlier, passing a number to an any_* type would also die
  - Fixed subification overloading: if Sub::Quote was loaded, this would be
    used, but any environment variables needed for the closure would not be
    included, which broke enums, among other things

* Thu Aug  3 2017 Paul Howarth <paul@city-fan.org> - 0.39-1
- Update to 0.39
  - Many bug fixes and improvements to the types created by
    {any,object}_{can,does,isa}_type; in some cases, an invalid value could
    cause an exception in type check itself, and in other cases, a value that
    failed a type check would cause an exception when generating a message
    describing the failure
  - The messages describing a failure for all of these types have been improved
  - You can now create anonymous *_does and *_isa types using the exports from
    Specio::Declare
- BR: perl-generators unconditionally
- BR: perl-interpreter rather than perl

* Sat Jul  1 2017 Paul Howarth <paul@city-fan.org> - 0.38-1
- Update to 0.38
  - Simplify checks for overloading to not call overload::Overloaded(); just
    checking the return value of overload::Method() is sufficient

* Tue May  9 2017 Paul Howarth <paul@city-fan.org> - 0.37-1
- Update to 0.37
  - Possible fix for very weird failures seen under threaded Perls with some
    modules that use Specio

* Tue Apr 11 2017 Paul Howarth <paul@city-fan.org> - 0.36-2
- Explicitly require List::MoreUtils::XS if we're using it in lieu of a recent
  List::Util; the List::MoreUtils::PP implementation does not work and
  List::MoreUtils no longer loads the XS itself
- Drop support for EOL distributions prior to F-13
  - Drop BuildRoot: and Group: tags
  - Drop explicit buildroot cleaning in %%install section
  - Drop explicit %%clean section
  - Drop workaround for building with Test::More < 0.96
  - Build the perl-Test-Specio sub-package unconditionally

* Mon Feb 20 2017 Paul Howarth <paul@city-fan.org> - 0.36-1
- Update to 0.36
  - Inlined coercions would attempt to coerce for every type that matched the
    value given, instead of stopping after the first type (GH#11)
  - Inlined coercions did not include the inline environment variables needed
    by the type from which the coercion was being performed (GH#8)
  - When you use the same type repeatedly as coderef (for example, as a
    constraint with Moo), it will only generate its subified form once, rather
    than regenerating it each time it is de-referenced
  - Added an API to Specio::Subs to allow you to combine type libraries and
    helper subs in one package for exporting; see the Specio::Exporter docs for
    more details
- Update patch for building with old List::Util versions

* Mon Feb 13 2017 Paul Howarth <paul@city-fan.org> - 0.35-1
- Update to 0.35
  - Added Specio::Subs, a module that allows you to turn one or more library's
    types into subroutines like is_Int() and to_Int()
  - Added an inline_coercion method to Specio constraints
- Update patch for building with old List::Util versions

* Sat Feb 11 2017 Paul Howarth <paul@city-fan.org> - 0.34-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_26_Mass_Rebuild

* Mon Jan 30 2017 Paul Howarth <paul@city-fan.org> - 0.34-1
- Update to 0.34
  - Packages with Specio::Exporter can now specify additional arbitrary subs to
    exporter; see the Specio::Exporter docs for details
  - Importing the same library twice in a given package would throw an
    exception; the second attempt to import is now ignored
- Update patch for building with old List::Util versions

* Wed Jan 25 2017 Paul Howarth <paul@city-fan.org> - 0.33-1
- Update to 0.33
  - Fixed a mistake in the SYNOPSIS for Specio::Declare; the example for the
    *_isa_type helpers was not correct
  - Removed the alpha warning from the docs; this is being used by enough of my
    modules on CPAN that I don't plan on doing any big breaking changes without
    a deprecation first
- Update patch for building with old List::Util versions

* Fri Jan 13 2017 Paul Howarth <paul@city-fan.org> - 0.32-1
- Update to 0.32
  - Fixed a bug in the inlining for types create by any_can_type() and
    object_can_type(); this inlining mostly worked by accident because of some
    List::Util XS magic, but this broke under the debugger (GH#6,
    https://github.com/houseabsolute/DateTime.pm/issues/49)
- Update patch for building with old List::Util versions

* Mon Nov  7 2016 Paul Howarth <paul@city-fan.org> - 0.31-1
- Update to 0.31
  - The stack trace contained by Specio::Exception objects no longer includes
    stack frames for the Specio::Exception package
  - Made the inline_environment() and description() methods public on type and
    coercion objects
- Update patch for building with old List::Util versions

* Thu Oct 27 2016 Paul Howarth <paul@city-fan.org> - 0.30-2
- Break some build dependency cycles by avoiding Moo/Mouse/Moose when
  bootstrapping

* Sun Oct 16 2016 Paul Howarth <paul@city-fan.org> - 0.30-1
- Update to 0.30
  - Fix a bug with the Sub::Quoted sub returned by $type->coercion_sub; if a
    type had more than one coercion, the generated sub could end up coercing
    the value to undef some of the time and, depending on hash key ordering,
    this could end up being a heisenbug that only occurred some of the time
- Update patch for building with old List::Util versions

* Mon Oct 10 2016 Paul Howarth <paul@city-fan.org> - 0.29-1
- Update to 0.29
  - Document Specio::PartialDump because you may want to use it as part of the
    failure message generation code for a type
- Update patch for building with old List::Util versions

* Mon Oct  3 2016 Paul Howarth <paul@city-fan.org> - 0.28-1
- Update to 0.28
  - Added a Test::Specio module to provide helpers for testing Specio libraries
  - Fixed another bug with a subtype of special types and inlining
- Introduce sub-package perl-Test-Specio to avoid dependencies on Test::Fatal
  and Test::More in main package
- Update patch for building with old List::Util versions

* Sun Oct  2 2016 Paul Howarth <paul@city-fan.org> - 0.27-1
- Update to 0.27
  - Cloning a type with coercions defined on it would cause an exception
  - Creating a subtype of a special type created by *_isa_type, *_can_type, or
    *_does_type, or enum would die when trying to inline type constraint
  - Removed the never-documented Any type
  - Added documentation for each type in Specio::Library::Builtins
- Update patch for building with old List::Util versions

* Mon Sep 26 2016 Paul Howarth <paul@city-fan.org> - 0.26-1
- Update to 0.26
  - Require Role::Tiny 1.003003, which should fix some test failures
- Update patch for building with old List::Util versions

* Mon Sep  5 2016 Paul Howarth <paul@city-fan.org> - 0.25-1
- Update to 0.25
  - Calling {any,object}_{isa,does}_type repeatedly in a package with the same
    class or role name would die; these subs are now special-cased to simply
    return an existing type for the given name when they receive a single
    argument (the name of the class or role)
- Update patch for building with old List::Util versions

* Fri Jul  1 2016 Paul Howarth <paul@city-fan.org> - 0.24-1
- Initial RPM version
